# 디스커버리 Go 언어 #

<디스커버리 Go 언어>의 예제 코드들과 북마크들을 모아 두었습니다.

## 북마크 ##

책의 내용과 관련 있는 링크들을 모았습니다.

### 1장 ###

* [Go 언어 홈페이지 (영어)](http://golang.org)
* [Go 언어 투어 (영어)](https://tour.golang.org/)
    * [형 추론 (영어)](https://tour.golang.org/basics/14)
* [Go 놀이터 (영어)](https://play.golang.org)
* [Effective Go](https://golang.org/doc/effective_go.html)
    * [세미콜론 (영어)](https://golang.org/doc/effective_go.html#semicolons)
* [The Go Blog](https://blog.golang.org)
    * [Go 선언 구문 (영어)](https://blog.golang.org/gos-declaration-syntax)
* [Go 언어 스펙 (영어)](https://golang.org/ref/spec)
    * [Go 언어 스펙: 불리언 형 (영어)](https://golang.org/ref/spec#Boolean_types)
* [Packages](https://golang.org/pkg)
    * [fmt](https://golang.org/pkg/fmt/)
* [위키백과: 하노이의 탑](https://ko.wikipedia.org/wiki/%ED%95%98%EB%85%B8%EC%9D%B4%EC%9D%98_%ED%83%91)


### 2장 ###

* [Go 언어 홈페이지 (영어)](http://golang.org)
    * [다운로드 (영어)](https://golang.org/dl/)
    * [설치 (영어)](https://golang.org/doc/install)
* [github.com](https://github.com)
    * [GoGetTools](https://github.com/golang/go/wiki/GoGetTools)
* [How to Write Go Code](https://golang.org/doc/code.html)
* [The Go Blog](https://blog.golang.org)
    * [Package Names](https://blog.golang.org/package-names)
* [IDEs and Plugins for Go](https://github.com/golang/go/wiki/IDEsAndTextEditorPlugins)
    * [LiteIDE](https://github.com/visualfc/liteide)
    * [Emacs Go Mode](https://github.com/dominikh/go-mode.el)
    * [vim-go](https://github.com/fatih/vim-go)
    * [Atom go-plus](https://atom.io/packages/go-plus)
    * [Wide](https://github.com/b3log/wide)
* [GoDoc](https://godoc.org)
* 윈도우용
    * [Chocolatey](https://chocolatey.org/)
    * [MinGW](http://www.mingw.org/)
    * [msysgit](https://msysgit.github.io/)

### 3장 ###

* [The Go Blog](https://blog.golang.org)
    * [Strings, bytes, runes and characters in Go](https://blog.golang.org/strings)
    * [Testable Examples in Go](https://blog.golang.org/examples)
    * [Go Slices: usage and internals](https://blog.golang.org/go-slices-usage-and-internals)
    * [Go maps in action](https://blog.golang.org/go-maps-in-action)
* [유니코드 (영문)](http://unicode.org/)
    * [한글 음절 (영문)](http://unicode.org/charts/PDF/UAC00.pdf)
* [How to Write Go Code](https://golang.org/doc/code.html)
    * [Testing](https://golang.org/doc/code.html#Testing)
* [Effective Go](https://golang.org/doc/effective_go.html)
    * [Commentary](https://golang.org/doc/effective_go.html#commentary)
    * [Defer](https://golang.org/doc/effective_go.html#defer)
* [Packages](https://golang.org/pkg)
    * [builtin](https://golang.org/pkg/builtin)
    * [strings](https://golang.org/pkg/strings)
    * [bytes](https://golang.org/pkg/bytes)
    * [strconv](https://golang.org/pkg/strconv)
        * [Atoi](https://golang.org/pkg/strconv/#Atoi)
        * [ParseInt](https://golang.org/pkg/strconv/#ParseInt)
        * [ParseFloat](https://golang.org/pkg/strconv/#ParseFloat)
        * [Itoa](https://golang.org/pkg/strconv/#Itoa)
        * [FormatInt](https://golang.org/pkg/strconv/#FormatInt)
    * [bufio](https://golang.org/pkg/bufio)
    * [fmt](https://golang.org/pkg/fmt/)
* [위키백과: 이진 검색 알고리즘](https://ko.wikipedia.org/wiki/이진_검색_알고리즘)

#### 추가 컨텐츠 ####

문자열 부분에 추가 컨텐츠가 있습니다.

* [문자열 예제](https://github.com/jaeyeom/gogo/tree/master/examples/strings)

### 4장 ###

* [Go 언어 투어 (영어)](https://tour.golang.org/)
    * [Pointers](https://tour.golang.org/moretypes/1)
* [Effective Go](https://golang.org/doc/effective_go.html)
    * [Multiple returns values](https://golang.org/doc/effective_go.html#multiple-returns)
* [Packages](https://golang.org/pkg)
    * [strings](https://golang.org/pkg/strings)
        * [Index](https://golang.org/pkg/strings/#Index)
    * [time](https://golang.org/pkg/time)
        * [Timer](https://golang.org/pkg/time/#Timer)
    * [path](https://golang.org/pkg/path)
        * [filepath](https://golang.org/pkg/path/filepath)
            * [Walk](https://golang.org/pkg/path/filepath/#Walk)
    * [regexp](https://golang.org/pkg/regexp/)
        * [Regexp.ReplaceAllStringFunc](https://golang.org/pkg/regexp/#Regexp.ReplaceAllStringFunc)
* [The Go Blog](https://blog.golang.org)
    * [Error handling and Go](https://blog.golang.org/error-handling-and-go)
* [Structure and Interpretation of Computer Programs](https://mitpress.mit.edu/sicp/full-text/book/book.html)
    * [1.3 Formulating Abstractions with Higher-Order Procedures](https://mitpress.mit.edu/sicp/full-text/book/book-Z-H-12.html#%_sec_1.3)
* [위키백과: 뉴턴 방법](https://ko.wikipedia.org/wiki/뉴턴_방법)


### 5장 ###

* [Effective Go](https://golang.org/doc/effective_go.html)
    * [Constants](https://golang.org/doc/effective_go.html#constants)
    * [Embedding](https://golang.org/doc/effective_go.html#embedding)
* [Go Source](https://golang.org/src)
    * [fmt/fmt_test.go](https://golang.org/src/fmt/fmt_test.go)
    * [net/http/fs.go](https://golang.org/src/net/http/fs.go)
    * [net/http/fs_test.go](https://golang.org/src/net/http/fs_test.go)
* [How to Write Go Code](https://golang.org/doc/code.html)
    * [Testing](https://golang.org/doc/code.html#Testing)
* [The Go Blog](https://blog.golang.org)
    * [Generating code](https://blog.golang.org/generate)
    * [Gobs of data](https://blog.golang.org/gobs-of-data)
* [Packages](https://golang.org/pkg)
    * [encoding](https://golang.org/pkg/encoding)
        * [json](https://golang.org/pkg/encoding/json)
        * [gob](https://golang.org/pkg/encoding/gob)
    * [sort](http://golang.org/pkg/sort)
* [위키백과: 사전식 순서](https://ko.wikipedia.org/wiki사전식_순서)


### 6장 ###

* [Writing Web Applications](https://golang.org/doc/articles/wiki/)
* [Advanced REST client](https://chrome.google.com/webstore/detail/advanced-rest-client/hgmloofddffdnphfgcellkdfbfbjeloo)
* [Packages](https://golang.org/pkg)
    * [html](https://golang.org/pkg/html)
        * [template](https://golang.org/pkg/html/template)
    * [text](https://golang.org/pkg/text)
        * [template](https://golang.org/pkg/text/template)
    * [net](https://golang.org/pkg/net)
        * [http](https://golang.org/pkg/net/http)
            * [FileServer](https://golang.org/pkg/net/http/#FileServer)
* [Gorilla Mux](https://github.com/gorilla/mux)
* [Mgo](https://labix.org/mgo)
* [The Go Blog](https://blog.golang.org)
    * [Error handling and Go](https://blog.golang.org/error-handling-and-go)


### 7장 ###

* [Go 언어 투어 (영어)](https://tour.golang.org/)
    * [Goroutines](https://tour.golang.org/concurrency/1)
* [The Go Blog](https://blog.golang.org)
    * [Go Concurrency Patterns: Context](https://blog.golang.org/context)
* [sieve.go](https://golang.org/doc/play/sieve.go)
* [Data Race Detector](https://golang.org/doc/articles/race_detector.html)
* [Packages](https://golang.org/pkg)
    * [sync](https://golang.org/pkg/sync)
        * [atomic](https://golang.org/pkg/atomic)


### 8장 ###

* [Wikipedia: Function overloading](https://en.wikipedia.org/wiki/function_overloading)
* [위키백과: 함수 오버로드](https://ko.wikipedia.org/wiki/함수_오버로드)
* [위키백과: 비지터 패턴](https://ko.wikipedia.org/wiki/비지터_패턴)
* [Packages](https://golang.org/pkg)
    * [reflect](https://golang.org/pkg/reflect)


## 소스 코드 ##

책에 있는 예제 코드들이 있는 곳의 경로입니다.

### 2장 ###

    github.com/jaeyeom/gogo/hanoi
    github.com/jaeyeom/gogo/seq/...


### 3장 ###

    github.com/jaeyeom/gogo/hangul
    github.com/jaeyeom/gogo/examples/strings/...
    github.com/jaeyeom/gogo/examples/array/...
    github.com/jaeyeom/gogo/examples/slice/...
    github.com/jaeyeom/gogo/examples/maps/...
    github.com/jaeyeom/gogo/examples/io/...


### 4장 ###

    github.com/jaeyeom/gogo/examples/function/...


### 5장 ###

    github.com/jaeyeom/gogo/task/...
    github.com/jaeyeom/gogo/interface/...


### 6장 ###

    github.com/jaeyeom/gogo/net/...


### 7장 ###

    github.com/jaeyeom/gogo/concurrency/...
    github.com/jaeyeom/gogo/examples/concurrency/...
    github.com/jaeyeom/gogo/seq/...


### 8장 ###

    github.com/jaeyeom/gogo/generate/...
    github.com/jaeyeom/gogo/examples/factory
    github.com/jaeyeom/gogo/examples/polymorph
    github.com/jaeyeom/gogo/examples/ref
    github.com/jaeyeom/gogo/examples/visitor

